﻿DeclareModule Plug
  Declare Create()
EndDeclareModule


Module Plug

UseModule AIMP
UseModule Unknown

Structure Plug Extends UnkSctuct
  *Core.IAIMPCore
  *Visual.IAIMPExtensionCustomVisualization
EndStructure

EnableExplicit

Procedure.s InfoGet(*This.Plug, Index.i)
  Protected Res.s
  Select Index
    Case #AIMP_PLUGIN_INFO_NAME
      Res = "VisualShare"
    Case #AIMP_PLUGIN_INFO_AUTHOR
      Res = "Пётр (pure-basic@yandex.ru)"
    Case #AIMP_PLUGIN_INFO_SHORT_DESCRIPTION
      Res = "Плагин визуализации"
    Case #AIMP_PLUGIN_INFO_FULL_DESCRIPTION
      Res = "Плагин визуализации предоставляющий доступ к данным спектра другим программам"
  EndSelect
  
  ProcedureReturn Res
EndProcedure

Procedure InfoGetCategories(*This.Plug)
  ProcedureReturn #AIMP_PLUGIN_CATEGORY_VISUALS
EndProcedure

Procedure Initialize(*This.Plug, *Core.IAIMPCore)
  Protected Res = #E_FAIL
  Protected *Visual.IAIMPExtensionCustomVisualization
  
  Share::Free(#True)
  
  *This\Core = *Core
  
  *Visual = Visual::Create()
  If *Visual
    Res = *Core\RegisterExtension(AIMP::?IID_IAIMPServiceVisualizations, *Visual)
    If Res = #S_NORMAL
      *This\Visual = *Visual
    Else
      Visual::Free(*Visual)
    EndIf
  EndIf
  
  ProcedureReturn Res
EndProcedure

Procedure Finalize(*This.Plug)
  If *This\Visual
    Visual::Free(*This\Visual)
    *This\Visual = 0
  EndIf
EndProcedure

Procedure SystemNotification(*This.Plug, NotifyID, *Data.IUnknown)
  
EndProcedure

Procedure Create()
  Protected *Struct.Plug
  
  *Struct = AllocateMemory(SizeOf(Plug))
  If *Struct
    InitializeStructure(*Struct, Plug)
    CopyMemory(AIMP::?IID_IUnknown, @*Struct\IID, SizeOf(GUID))
    *Struct\VT = ?Plug
  EndIf
  
  ProcedureReturn *Struct
  
  DataSection
    Plug:
    Unknown::UnkProc
    Data.i @InfoGet()
    Data.i @InfoGetCategories()
    Data.i @Initialize()
    Data.i @Finalize()
    Data.i @SystemNotification()
  EndDataSection
EndProcedure

EndModule
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; Folding = --
; EnableUnicode
; EnableXP